$missionName = "MapVote";
$MVVersion = "MapVote 0.5";

// FILENAME:      MapVote.cs
// AUTHORS:       [OF] Pincushion
// LAST UPDATED:  May 2, 2001
//
// This script allows players to vote for the next map their server will run.
// It is for use by administrators of dedicated servers. Players do not need it.
// Supports up to 50 maps. It has been tested with DM maps, and probably works
// for TDM and CTF too.  It is compatible with QBan.
// MapVote doesn't work with OVStdlib 3.5, but if and when OV 4.0 is released
// it will work.  In general, mixing different game mission types probably
// won't work, though TDM/CTF might as long as the teams are Blue and Purple.
// 
// INSTALLATION:
// Copy MapVote.cs and MapVote.mis to your starsiege/multiplayer folder.
// Then go to your starsiege folder and edit your favorite Server_XXX.cs
// file. (You might prefer to copy it to Server_XXX_MapVote.cs first.)
// Scroll down until you find the lines that look like:
//
//   $MissionCycling::Stage0 = "CTF_Winter_Wasteland";
//   $MissionCycling::Stage1 = "CTF_Circular_Logic";
//   $MissionCycling::Stage2 = "CTF_Balance_of_Power";
//   $MissionCycling::Stage3 = "CTF_City_on_the_Edge";
//
// Copy the first line and add it to the end of the list. Make sure to set
// its Stage number one higher than the previous maximum. Then change the map
// name for Stage0 to "MapVote". It should now look like:
//
//   $MissionCycling::Stage0 = "MapVote";
//   $MissionCycling::Stage1 = "CTF_Circular_Logic";
//   $MissionCycling::Stage2 = "CTF_Balance_of_Power";
//   $MissionCycling::Stage3 = "CTF_City_on_the_Edge";
//   $MissionCycling::Stage4 = "CTF_Winter_Wasteland";
//
// Make sure the $server::Mission is set to Stage0 like so:
//
//   $server::Mission = $MissionCycling::Stage0;
//
// You might also add "MV" or "MapVote" to your $server::Hostname to let
// players know you're running this script - but it isn't strictly necessary.
//
// That's it! Play starts with the MapVote map, where players shoot Prometheus
// to vote. After a short time (see $MVTime below) the votes are tallied and
// the winning map is started. When that map finishes MapVote runs again,
// and so on.
//
// Credit and thanks go to Orogogus for the original concept and
// implementation of interactively selectable maps.  Thanks to DINGO and
// DRATSAB for testing and feedback.
//
// Visit http://www.geocities.com/SoHo/Nook/9351/maps/ for more info.
//------------------------------------------------------------------------------

$MVTime = 90; // vote duration (in seconds)

// Comment out to disable Map Vote History
if ($MVVHFile == "") $MVVHFile = "MapVoteVH.cs";

$MVAboutTheGame =
 "You have "@$MVTime@
 " seconds after the first player joins to cast your vote for the next map. "@
 "Ties are resolved by random selection. "@
 "Shoot Frosty for voting statistics.\n\n"@
 "Visit http://www.geocities.com/SoHo/Nook/9351/maps/ for maps and info.";

$MVEdit = $me::enableMissionEditor; // disables object creation in ME

function MVLoad() {
	if ($MVEdit) return;
	if ($MVLoaded) return;
	// Only have to do this once per server start.
	$MVLoaded = 1;
	$MVColor = "<f2>";
	$MVFlash = 0;
	$MVDM = 20;
	// Automagically build map list.
	$MVNextMap = 1;
	$MissionCycling::Stage0 = "MapVote"; $MVMap[0] = $MissionCycling::Stage1;
	$MissionCycling::Stage1 = ""; $MVMap[1] = $MissionCycling::Stage2;
	$MissionCycling::Stage2 = ""; $MVMap[2] = $MissionCycling::Stage3;
	$MissionCycling::Stage3 = ""; $MVMap[3] = $MissionCycling::Stage4;
	$MissionCycling::Stage4 = ""; $MVMap[4] = $MissionCycling::Stage5;
	$MissionCycling::Stage5 = ""; $MVMap[5] = $MissionCycling::Stage6;
	$MissionCycling::Stage6 = ""; $MVMap[6] = $MissionCycling::Stage7;
	$MissionCycling::Stage7 = ""; $MVMap[7] = $MissionCycling::Stage8;
	$MissionCycling::Stage8 = ""; $MVMap[8] = $MissionCycling::Stage9;
	$MissionCycling::Stage9 = ""; $MVMap[9] = $MissionCycling::Stage10;
	$MissionCycling::Stage10 = ""; $MVMap[10] = $MissionCycling::Stage11;
	$MissionCycling::Stage11 = ""; $MVMap[11] = $MissionCycling::Stage12;
	$MissionCycling::Stage12 = ""; $MVMap[12] = $MissionCycling::Stage13;
	$MissionCycling::Stage13 = ""; $MVMap[13] = $MissionCycling::Stage14;
	$MissionCycling::Stage14 = ""; $MVMap[14] = $MissionCycling::Stage15;
	$MissionCycling::Stage15 = ""; $MVMap[15] = $MissionCycling::Stage16;
	$MissionCycling::Stage16 = ""; $MVMap[16] = $MissionCycling::Stage17;
	$MissionCycling::Stage17 = ""; $MVMap[17] = $MissionCycling::Stage18;
	$MissionCycling::Stage18 = ""; $MVMap[18] = $MissionCycling::Stage19;
	$MissionCycling::Stage19 = ""; $MVMap[19] = $MissionCycling::Stage20;
	$MissionCycling::Stage20 = ""; $MVMap[20] = $MissionCycling::Stage21;
	$MissionCycling::Stage21 = ""; $MVMap[21] = $MissionCycling::Stage22;
	$MissionCycling::Stage22 = ""; $MVMap[22] = $MissionCycling::Stage23;
	$MissionCycling::Stage23 = ""; $MVMap[23] = $MissionCycling::Stage24;
	$MissionCycling::Stage24 = ""; $MVMap[24] = $MissionCycling::Stage25;
	$MissionCycling::Stage25 = ""; $MVMap[25] = $MissionCycling::Stage26;
	$MissionCycling::Stage26 = ""; $MVMap[26] = $MissionCycling::Stage27;
	$MissionCycling::Stage27 = ""; $MVMap[27] = $MissionCycling::Stage28;
	$MissionCycling::Stage28 = ""; $MVMap[28] = $MissionCycling::Stage29;
	$MissionCycling::Stage29 = ""; $MVMap[29] = $MissionCycling::Stage30;
	$MissionCycling::Stage30 = ""; $MVMap[30] = $MissionCycling::Stage31;
	$MissionCycling::Stage31 = ""; $MVMap[31] = $MissionCycling::Stage32;
	$MissionCycling::Stage32 = ""; $MVMap[32] = $MissionCycling::Stage33;
	$MissionCycling::Stage33 = ""; $MVMap[33] = $MissionCycling::Stage34;
	$MissionCycling::Stage34 = ""; $MVMap[34] = $MissionCycling::Stage35;
	$MissionCycling::Stage35 = ""; $MVMap[35] = $MissionCycling::Stage36;
	$MissionCycling::Stage36 = ""; $MVMap[36] = $MissionCycling::Stage37;
	$MissionCycling::Stage37 = ""; $MVMap[37] = $MissionCycling::Stage38;
	$MissionCycling::Stage38 = ""; $MVMap[38] = $MissionCycling::Stage39;
	$MissionCycling::Stage39 = ""; $MVMap[39] = $MissionCycling::Stage40;
	$MissionCycling::Stage40 = ""; $MVMap[40] = $MissionCycling::Stage41;
	$MissionCycling::Stage41 = ""; $MVMap[41] = $MissionCycling::Stage42;
	$MissionCycling::Stage42 = ""; $MVMap[42] = $MissionCycling::Stage43;
	$MissionCycling::Stage43 = ""; $MVMap[43] = $MissionCycling::Stage44;
	$MissionCycling::Stage44 = ""; $MVMap[44] = $MissionCycling::Stage45;
	$MissionCycling::Stage45 = ""; $MVMap[45] = $MissionCycling::Stage46;
	$MissionCycling::Stage46 = ""; $MVMap[46] = $MissionCycling::Stage47;
	$MissionCycling::Stage47 = ""; $MVMap[47] = $MissionCycling::Stage48;
	$MissionCycling::Stage48 = ""; $MVMap[48] = $MissionCycling::Stage49;
	$MissionCycling::Stage49 = ""; $MVMap[49] = $MissionCycling::Stage50;
	$MVNMap = 0;
	echo($MVVersion);
	for (%i=0;%i<50;%i++)
		if ($MVMap[%i] != "") {
			echo("Map "@%i+1@": "@$MVMap[%i]);
			$MVNMap++;
		}
	echo($MVNMap@" maps.");
	MVVHLoad();
}

// Flashing effect inspired by Raven [M.I.B]
function MVFlash(%vid,%x) {
	if (!$MVFlash) return;
	%i = (%x+$MVTime)%4;
	if (%i == 0) %c = red; else
	if (%i == 1) %c = blue; else
	if (%i == 2) %c = yellow; else
	if (%i == 3) %c = purple;
	setVehicleSpecialIdentity(%vid,on,%c);
}

function MVCheck() {
	$MVTime--;
	if ($MVTime) {
		%npid = playerManager::getPlayerCount();
		%nvotes = 0;
		for (%i=0;%i<%npid;%i++) {
			%pid = playerManager::getPlayerNum(%i);
			%vid = playerManager::playerNumToVehicleId(%pid);
			if (%vid) {
				MVFlash(%vid,%vid);
				if (%vid.vi) %nvotes++;
			}
		}
		if (%nvotes < %npid) {
			schedule("MVCheck();",1);
			return;
		}
		%msg = "All players have voted, tallying votes...";
	} else
		%msg = "Time's up, tallying votes...";
	%wav = "Trans_data.wav";
	say(0,0,$MVColor@%msg,%wav);
	%map = MVCount();
	schedule("MVEnd(\""@%map@"\");",2);
}

function MVCount() {
	for (%i=0;%i<$MVNMap;%i++) {%v[%i] = 0;}
	%npid = playerManager::getPlayerCount();
	for (%i=0;%i<%npid;%i++) {
		%pid = playerManager::getPlayerNum(%i);
		%vid = playerManager::playerNumToVehicleId(%pid);
		if (%vid) {
			%vi = %vid.vi - 1;
			if (%vi != -1) {
//say(0,0,$MVColor@getName(%vid)@" voted for "@$MVMap[%vi]@".");
				%v[%vi]++;
				//%vid.vi = 0;
				MVVHInc($MVMap[%vi]);
			}
		}
	}
	%maxv = 0;    // max vote so far
	%maxn = 0;    // # max vote map indices in %maxi[]
	%maxi[0] = 0; // indices of maps with %maxv votes
	for (%i=0;%i<$MVNMap;%i++) {
		if (%v[%i]) {
			%plural = ""; if (%v[%i]>1) {%plural = "s";}
			say(0,0,$MVColor@%v[%i]@" vote"@%plural@" for "@$MVMap[%i]@".");
			if (%v[%i] == %maxv) {
				%maxi[%maxn] = %i;
				%maxn++;
			} else if (%v[%i] > %maxv) {
				%maxv = %v[%i];
				%maxi[0] = %i;
				%maxn = 1;
			}
		}
	}
	if (%maxn) {
		if (%maxn > 1) {
			// tie, pick winner at random
			%mi = %maxi[randomInt(0,%maxn-1)];
			%plural = ""; if (%maxn>1) {%plural = "s";}
			%msg = %maxn@" map"@%plural;
			%plural = ""; if (%maxv>1) {%plural = "s";}
			%msg = %msg@" tied with "@%maxv@" vote"@%plural@"...";
			%msg = %msg@" "@$MVMap[%mi]@" wins random tie-breaker.";
			say(0,0,$MVColor@%msg);
		} else {
			// single winner
			%mi = %maxi[0];
			%plural = ""; if (%maxv>1) {%plural = "s";}
			say(0,0,$MVColor@$MVMap[%mi]@" wins with "@%maxv@" vote"@%plural@".");
		}
		MVVHSave();
		$MVNextMap = %mi + 1;
	} else {
		// no votes
		if (playerManager::getPlayerCount()) {
			%mi = $MVNextMap;
			$MVNextMap = %mi + 1;
		} else {
			// no players remain, reset to MapVote
			%mi = -1;
		}
		say(0,0,$MVColor@"No votes were cast.");
	}
	if ($MVNextMap >= $MVNMap) $MVNextMap = 0;
	if ((%mi < 0) || (%mi >= $MVNMap)) return "MapVote.cs";
	return $MVMap[%mi];
}

function MVEnd(%map) {
	$MissionCycling::Stage1 = %map;
	$server::Mission = $MissionCycling::Stage1;
	missionEndConditionMet();
}

function MVVHInc(%map) {
	if ($MVVHFile == "") return;
	for (%i=0;%i<$MVVHN;%i++)
		if (%map == $MVVHMap[%i]) {$MVVHCnt[%i]++; return;}
	$MVVHMap[%i] = %map;
	$MVVHCnt[%i] = 1;
	$MVVHN++;
}

function MVVHSort() {
	if ($MVVHFile == "") return;
	for (%i=0;%i<$MVVHN-1;%i++)
		for (%k=%i;%k<$MVVHN;%k++)
			if ($MVVHCnt[%k] < $MVVHCnt[%i]) {
				%tmp = $MVVHMap[%k];
				$MVVHMap[%k] = $MVVHMap[%i];
				$MVVHMap[%i] = %tmp;
				%tmp = $MVVHCnt[%k];
				$MVVHCnt[%k] = $MVVHCnt[%i];
				$MVVHCnt[%i] = %tmp;
			}
}

function MVVHSave() {
	%fn = $MVVHFile;
	if (%fn == "") return;
	MVVHSort();
	$MVVHGameN++;
	$MVVHTitle = $missionName@" Vote History";
	%out = "";
	%out = %out@"\n$MVVHSince=\""@$MVVHSince@"\";";
	%out = %out@"\n$MVVHGameN="@$MVVHGameN@";";
	%out = %out@"\n$MVVHN="@$MVVHN@";";
	for (%i=0;%i<$MVVHN;%i++) {
		%out = %out@"\n$MVVHMap["@%i@"]=\""@$MVVHMap[%i]@"\";";
		%out = %out@"\n$MVVHCnt["@%i@"]="@$MVVHCnt[%i]@";";
	}
	export("$MVVHTitle",%fn,overwrite);
	fileWrite(%fn,append,%out);
	echo("Saved Vote History to "@%fn);
}

function MVVHLoad() {
	if ($MVVHFile == "") return;
	if ($MVVHN) return;
	$MVVHN = 0;
	$MVVHGameN = 0;
	$MVVHSince = getDate();
// $MVVHMap[] - map names
// $MVVHCnt[] - map counts
	if (isFile($MVVHFile)) exec($MVVHFile);
}

function MVVHShow(%pid) {
	if ($MVVHFile == "") return;
	if (dataRetrieve(%pid,MVVHShow) == 1) return;
	dataStore(%pid,MVVHShow,1);
	schedule("dataStore("@%pid@",MVVHShow,0);",15);
	%sum=0;
	for (%i=0;%i<$MVVHN;%i++) %sum=%sum+$MVVHCnt[%i];
	%msg = $MVColor@$server::Hostname@" running "@$MVVersion@
		"\n "@$MVVHGameN@" games and "@%sum@" votes since "@$MVVHSince;
	for (%i=0;%i<$MVVHN;%i++) {
		%n = $MVVHCnt[%i];
		if (%n) {
			%pct = floor((100*%n)/%sum+0.5);
			%msg = %msg@"\n "@%n@" ("@%pct@"%) votes for "@$MVVHMap[%i];
		}
	}
	say(%pid,0,%msg);
}

function MVExplain(%pid) {
	say(%pid,0,$MVColor@"Target and shoot Prometheus to vote. There are "@$MVNMap@" maps to choose from.");
}

function MVStart() {
	if ($MVEdit) return;
	%MGid = getObjectId("MissionGroup");
	%bid = getObjectId("MissionGroup/Base");
	%x = getPosition(%bid,x);
	%y = getPosition(%bid,y);
	%y += ($MVNMap*$MVDM)/2;
	%mid = newObject("Map",SimShapeGroup);
	addToSet(%MGid,%mid);
	for (%i=0;%i<$MVNMap;%i++) {
		%name = $MVMap[%i];
		%id = newObject(%name,Herc,29);
		addToSet(%mid,%id);
		setTeam(%id,*IDSTR_TEAM_RED);
		%id.mi = %i+1;
		order(%id,"Shutdown",true);
		%z = getTerrainHeight(%x,%y);
		%rot = 90;
		setPosition(%id,%x,%y,%z,%rot);
		%y = %y-$MVDM;
	}
	schedule("MVCheck();",1);
}

function MVSetRules() {
	%rules = "<F2>GAME TYPE: \n<F0>" @
		$MVVersion @
		"\n\n" @
		"<tIDMULT_TDM_MAPNAME>" @
		$MVAboutTheGame @
		"\n\n" @
		"<tIDMULT_STD_ITEMS>" ;
	setGameInfo(%rules);
}

// this has to be called after the definition of MVSetRules
MVSetRules();

function MVVote(%ee,%er) {
	if (%ee.mi == 0) return;
	if (%ee.mi == %er.vi) return;
	%er.vi = %ee.mi;
	%wav = "bigFoot_l.wav";
	say(0,0,$MVColor@getName(%er)@" voted for "@$MVMap[%er.vi-1]@".",%wav);
}

function vehicle::onScan(%ee,%er) {
	MVVote(%ee,%er);
}

function vehicle::onAttacked(%ee,%er) {
	healObject(%ee,50000);
	MVVote(%ee,%er);
}

function vehicle::onTargeted(%ee,%er) {
	if (%ee.mi == 0) return;
	%pid = playerManager::vehicleIdToPlayerNum(%er);
	%wav = "bptslct.wav";
	say(%pid,0,$MVColor@"Shoot this big glitch to vote for "@$MVMap[%ee.mi-1]@".",%wav);
}

function structure::onAttacked(%ee,%er) {
	%pid = playerManager::vehicleIdToPlayerNum(%er);
	MVVHShow(%pid);
}

function vehicle::onAdd(%vid) {
	if ($MVEdit) return;
	%pid = playerManager::vehicleIdToPlayerNum(%vid);
	if (%pid == 0) return;
	MVExplain(%pid);
	%channel = 1;
	setHudTimer($MVTime,-1,"Voting Ends",%channel,%pid);
	MVFlash(%vid,%vid);
}

function onMissionStart() {
	temperateSounds();
	MVStart();
}

function onMissionLoad() {
	cdAudioCycle("Cloudburst", "SS3", "Watching");
	MVLoad();
}
